routes/web.php
<?php

use App\Http\Controllers\DashboardController;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;
use App\Http\Controllers\PengumumanController;
use App\Http\Controllers\PermissionController;
use App\Http\Controllers\ProductCategoryController;
use App\Http\Controllers\ProductController;
use App\Http\Controllers\ProfileController;
use App\Http\Controllers\RoleController;
use App\Http\Controllers\SettingController;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Auth::routes();

Route::get('/', function () {
    return redirect()->route('login');
});

Route::middleware(['auth', 'permission'])->group(function () {
    Route::group(['prefix' => 'dashboard', 'as' => 'dashboard.'], function () {
        Route::get('/', [DashboardController::class, 'index'])->name('index');
    });

    Route::group(['prefix' => 'blank', 'as' => 'blank.'], function () {
        Route::get('/', function () {
            return view('sample.blank.index');
        })->name('index');
    });

    Route::group(['prefix' => 'product', 'as' => 'product.'], function () {
        Route::get('/', [ProductController::class, 'index'])->name('index');
        Route::get('/create', [ProductController::class, 'create'])->name('create');
        Route::post('/store', [ProductController::class, 'store'])->name('store');
        Route::get('/edit/{product}', [ProductController::class, 'edit'])->name('edit');
        Route::patch('/update/{product}', [ProductController::class, 'update'])->name('update');
        Route::delete('/destroy/{product}', [ProductController::class, 'destroy'])->name('destroy');
    });

    Route::group(['prefix' => 'product-category', 'as' => 'product-category.'], function () {
        Route::get('/', [ProductCategoryController::class, 'index'])->name('index');
        Route::get('/create', [ProductCategoryController::class, 'create'])->name('create');
        Route::post('/store', [ProductCategoryController::class, 'store'])->name('store');
        Route::get('/edit/{product_category}', [ProductCategoryController::class, 'edit'])->name('edit');
        Route::patch('/update/{product_category}', [ProductCategoryController::class, 'update'])->name('update');
        Route::delete('/destroy/{product_category}', [ProductCategoryController::class, 'destroy'])->name('destroy');
    });
    
    Route::group(['prefix' => 'setting', 'as' => 'setting.'], function () {
        Route::group(['prefix' => 'profile', 'as' => 'profile.'], function () {
            Route::get('/', [ProfileController::class, 'index'])->name('index');
            Route::patch('update', [ProfileController::class, 'update'])->name('update');
        });

        Route::group(['prefix' => 'permission', 'as' => 'permission.'], function () {
            Route::get('/', [PermissionController::class, 'index'])->name('index');
            Route::patch('update/{permission}', [PermissionController::class, 'update'])->name('update');
            Route::post('assign-revoke', [PermissionController::class, 'assignRevoke'])->name('assign_revoke');
            Route::get('refresh', [PermissionController::class, 'refresh'])->name('refresh');
            Route::get('refresh-and-assign', [PermissionController::class, 'refreshAndAssign'])->name('refresh_and_assign');
            Route::delete('destroy/{permission}', [PermissionController::class, 'destroy'])->name('destroy');
        });

        Route::group(['prefix' => 'role', 'as' => 'role.'], function () {
            Route::get('/', [RoleController::class, 'index'])->name('index');
            Route::post('store', [RoleController::class, 'store'])->name('store');
            Route::patch('update/{role}', [RoleController::class, 'update'])->name('update');
            Route::delete('destroy/{role}', [RoleController::class, 'destroy'])->name('destroy');
        });
    });

});

app/Models/ProductCategory.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Cviebrock\EloquentSluggable\Sluggable;
use Illuminate\Support\Facades\File;

class ProductCategory extends Model
{
    use HasFactory;
    use Sluggable;

    protected $fillable = [
        'name',
        'slug',
        'image',
    ];

    public function getRouteKeyName()
    {
        return 'slug';
    }

    public function sluggable(): array
    {
        return [
            'slug' => [
                'source' => 'name'
            ]
        ];
    }

    public function products()
    {
        return $this->hasMany(Product::class);
    }

    public function getImage()
    {
        $image_path = $this->attributes['image'];
        $isExists = File::exists(public_path($image_path));
        if ($isExists and $this->attributes['image'] != '') {
            return asset($image_path);
        } else {
            return asset('default/avatar.png');
        }
    }
}

app/Http/Controllers/ProductCategoryController.php
<?php

namespace App\Http\Controllers;

use App\DataTables\ProductCategoryDataTable;
use App\Http\Requests\ProductCategoryRequest;
use App\Models\ProductCategory;
use Exception;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\File;
use Illuminate\Support\Facades\Log;

class ProductCategoryController extends Controller
{

    const CATEGORIES_FOLDER = 'categories';

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index(ProductCategoryDataTable $productCategoryDataTable)
    {
        return $productCategoryDataTable->render('product-category.index');
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        // abort(404);
        return view('product-category.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(ProductCategoryRequest $request)
    {
        try{
            $data = $request->validated();

            $image = uploadFileHttp($data['image'], self::CATEGORIES_FOLDER);
        
            if($image != false){
                $data['image'] = $image;
            }else{
                throw 'Failed to upload menu category image';
            }

            ProductCategory::create($data);
        }catch(Exception $e){
            Log::error($e->getMessage());
            return redirect()->back()->withInput()->with('error', trans('flash.failed.store'));
        }

        return redirect()->route('product-category.index')->with('success', trans('flash.success.store'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Models\ProductCategory  $product_category
     * @return \Illuminate\Http\Response
     */
    public function edit(ProductCategory $product_category)
    {
        $data = [
            'product_category' => $product_category
        ];

        return view('product-category.edit', $data);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Models\ProductCategory  $product_category
     * @return \Illuminate\Http\Response
     */
    public function update(ProductCategoryRequest $request, ProductCategory $product_category)
    {
        try{
            $data = $request->validated();

            if(isset($data['image'])){
                $image = uploadFileHttp($data['image'], self::CATEGORIES_FOLDER);
                
                if($image != false){
                    $data['image'] = $image;
                }else{
                    throw 'Failed to upload menu category image';
                }
            }

            $product_category->update($data);
        }catch(Exception $e){
            Log::error($e->getMessage());
            return redirect()->back()->withInput()->with('error', trans('flash.failed.update'));
        }

        return redirect()->route('product-category.index')->with('success', trans('flash.success.update'));
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\ProductCategory  $product_category
     * @return \Illuminate\Http\Response
     */
    public function destroy(ProductCategory $product_category)
    {
        try{
            if(File::exists(public_path($product_category->image))){ 
                File::delete(public_path($product_category->image));
            };

            $product_category->delete();
        }catch(Exception $e){
            Log::error($e->getMessage());
            return response([
                'message' => trans('flash.failed.delete')
            ], 500);
        }

        return response([
            'message' => trans('flash.success.delete')
        ], 200);
    }
}

resources/views/product-category/create.blade.php
@extends('layouts.app')
@section('content')
<div class="container-fluid p-0">
    <h1 class="h3 mb-3">Product Category</h1>

    <div class="row">
        <div class="col-12">
            <div class="card">
                <div class="card-header">
                    <h5 class="card-title mb-0">Create Product Category</h5>
                </div>
                <div class="card-body">
                    @include('layouts.flash')
                    {!! Form::open(['route' => 'product-category.store', 'enctype' => 'multipart/form-data']) !!}
                        @include('product-category.form')

                        <div class="mt-3">
                            <a href="{{ route('product-category.index') }}" class="btn btn-sm btn-danger">Cancel</a>
                            <button class="btn btn-sm btn-primary" type="submit">Save</button>
                        </div>
                    {!! Form::close() !!}
                </div>
            </div>
        </div>
    </div>

</div>
@endsection

resources/views/product-category/datatable-action.blade.php
<a href="{{ route('product-category.edit', $slug) }}" class="btn btn-sm btn-warning">Edit</a>
<button onclick="deleteModel('{{ route('product-category.destroy', $slug) }}', 'productCategoryDatatable', 'product category', 'product category {{ $name }} will deleted')" class="btn btn-sm btn-danger">Delete</button>

resources/views/product-category/edit.blade.php
@extends('layouts.app')
@section('content')
<div class="container-fluid p-0">
    <h1 class="h3 mb-3">Product Category</h1>

    <div class="row">
        <div class="col-12">
            <div class="card">
                <div class="card-header">
                    <h5 class="card-title mb-0">Create Product Category</h5>
                </div>
                <div class="card-body">
                    @include('layouts.flash')
                    {!! Form::model($product_category, ['route' => ['product-category.update', $product_category], 'enctype' => 'multipart/form-data', 'method' => 'patch']) !!}
                        @include('product-category.form')

                        <div class="mt-3">
                            <a href="{{ route('product-category.index') }}" class="btn btn-sm btn-danger">Cancel</a>
                            <button class="btn btn-sm btn-primary" type="submit">Save</button>
                        </div>
                    {!! Form::close() !!}
                </div>
            </div>
        </div>
    </div>

</div>
@endsection

resources/views/product-category/form.blade.php
<div class="col-12 col-md-6">
    <div class="row">
        <div class="col-12 col-md-6 pb-3 pb-md-0">
            {!! Form::label('image', 'Image', ['class' => 'mb-1']) !!}
            {!! Form::file('image', ['class' => 'form-control', 'id' => 'images']) !!}
        </div>
    </div>

    <div class="row  mt-3">
        <div class="col-12 pb-3 pb-md-0">
            {!! Form::label('name', 'Name', ['class' => 'mb-1']) !!}
            {!! Form::text('name', null, ['class' => 'form-control', 'id' => 'name']) !!}
        </div>
    </div>
</div>

@push('scripts')
    <script>
        document.addEventListener('DOMContentLoaded', function() {
            FilePond.registerPlugin(
                FilePondPluginFileEncode,
                FilePondPluginFileValidateSize,
                FilePondPluginFileValidateType,
                FilePondPluginImageExifOrientation,
                FilePondPluginImagePreview
            )
            let options
            let imageUrl
            const url = window.location

            options = {
                acceptedFileTypes: ['image/png', 'image/jng', 'image/jpeg'],
                maxFileSize: '2MB',
                allowMultiple : true,
                maxFiles: 2,
                labelIdle: 'Drag & drop gambar atau <span class="filepond--label-action">cari di file manager</span>',
            }

            if (url.pathname.includes('edit')) {
                imageUrl = document.getElementById('image').getAttribute('image')
                options.files = [{
                    source: imageUrl,
                    options: {
                        type: 'remote'
                    }
                }]
            }

            const filePond = FilePond.create(
                document.getElementById('image'), options
            )

            filePond.on('error', (error) => {
                console.log(error)
                if (error.main == 'File is too large') {
                    console.log(error.main)
                }
            })

            filePond.on('warning', (warning) => {
                console.log(warning)
                if (warning.body == 'Max files') {
                    console.log('Max file exceeded')
                }
            })

            filePond.on('addfile', (error, file) => {
                if (error) {
                    console.log('Oh no', error)
                    return
                }

                console.log('File added', file)
            })

            filePond.on('removefile', (error, file) => {
                if (error) {
                    console.log('Oh no', error)
                    return
                }

                console.log('File removed', file)
            })
        })


    </script>
@endpush

resources/views/product-category/index.blade.php
@extends('layouts.app')
@push('styles')
    <link rel="stylesheet" type="text/css" href="{{ asset('plugin/datatables/datatables.min.css') }}" />
@endpush

@section('content')
<div class="container-fluid p-0">
    <h1 class="h3 mb-3">Product Category</h1>

    <div class="row">
        <div class="col-12">
            <div class="card">
                <div class="card-header">
                    <div class="row">
                        <div class="col-6">
                            <h5 class="card-title mb-0">Product Category</h5>
                        </div>
                        <div class="col-6 text-right">
                            <a href="{{ route('product-category.create') }}" class="btn btn-sm btn-primary">Add new</a>
                        </div>
                    </div>
                </div>
                <div class="card-body">
                    @include('layouts.flash')
                    {!! $dataTable->table(['width' => '100%']) !!}
                </div>
            </div>
        </div>
    </div>

</div>
@endsection

@push('scripts')
    <script type="text/javascript" src="{{ asset('plugin/datatables/datatables.min.js') }}"></script>
    {!! $dataTable->scripts() !!}
@endpush